function _ts_decorate(decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for(var i = decorators.length - 1; i >= 0; i--)if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
}
function _ts_metadata(k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
}
import { PrimaryColumn, Entity, Index, JoinColumn, Column, OneToOne } from "typeorm";
import { Note } from "./note.js";
import { id } from "../id.js";
export let PromoNote = class PromoNote {
    noteId;
    note;
    expiresAt;
    totalCredits;
    remainingCredits;
    //#region Denormalized fields
    userId;
};
_ts_decorate([
    PrimaryColumn(id()),
    _ts_metadata("design:type", Object)
], PromoNote.prototype, "noteId", void 0);
_ts_decorate([
    OneToOne((type)=>Note, {
        onDelete: "CASCADE"
    }),
    JoinColumn(),
    _ts_metadata("design:type", Object)
], PromoNote.prototype, "note", void 0);
_ts_decorate([
    Column("timestamp with time zone"),
    _ts_metadata("design:type", typeof Date === "undefined" ? Object : Date)
], PromoNote.prototype, "expiresAt", void 0);
_ts_decorate([
    Column("integer", {
        default: 0
    }),
    _ts_metadata("design:type", Number)
], PromoNote.prototype, "totalCredits", void 0);
_ts_decorate([
    Column("integer", {
        default: 0
    }),
    _ts_metadata("design:type", Number)
], PromoNote.prototype, "remainingCredits", void 0);
_ts_decorate([
    Index(),
    Column({
        ...id(),
        comment: "[Denormalized]"
    }),
    _ts_metadata("design:type", Object)
], PromoNote.prototype, "userId", void 0);
PromoNote = _ts_decorate([
    Entity()
], PromoNote);
